#include <ub/ub_decl.h>
#include <ub/ub_task.h>

UB_DECLARE_FUNC(int, ub_oom_lock(void))
UB_DECLARE_FUNC(struct user_beancounter *, ub_oom_select_worst(void))
UB_DECLARE_VOID_FUNC(ub_oom_mm_killed(struct mm_struct *mm))
UB_DECLARE_VOID_FUNC(ub_oom_unlock(void))
UB_DECLARE_VOID_FUNC(ub_oom_task_dead(struct task_struct *tsk))

#ifdef CONFIG_USER_RESOURCE
extern int oom_generation;
extern int oom_kill_counter;
#define ub_oom_start() do {						\
		current->task_bc.oom_generation = oom_generation;	\
	} while (0)
#define ub_oom_task_match(ub, tsk) ({					\
		struct user_beancounter *mub;				\
		for (mub = (tsk)->mm->mm_ub; mub; mub = mub->parent)	\
			if (mub == ub)					\
				break;					\
		mub == ub;						\
	})
#define ub_oom_task_killed() do { oom_kill_counter++; } while (0)
#else
#define ub_oom_start()			do { } while (0)
#define ub_oom_task_match(ub, tsk)	(1)
#define ub_oom_task_killed()		do { } while (0)
#endif
